/* 70-762 Lesson 12 Lab 2 - Using UPDATE STATISTICS */

/*Example 1  */
-->>>>>>>>>>Using UPDATE STATISTICS
-------OPTIONS-----------------
/*
FULLSCAN
	Scans all rows in table or indexed view
SAMPLE
	Specifies number or percentage to scan
RESAMPLE
	Updates each statistic using most recent sample rate
Options omitted
	Uses default sample size 
NORECOMPUTE
	Disables automatic statistics update option, AUTO_UPDATE_STATISTICS, for specified statistics 
	Query optimizer completes this statistics update and disables future updates
	To re-enable AUTO_UPDATE_STATISTICS option behavior, 
	run UPDATE STATISTICS again without NORECOMPUTE option or run sp_autostats 
*/

USE WideWorldImporters;
GO

DBCC SHOW_STATISTICS ('Sales.SpecialDeals', 
	FK_Sales_SpecialDeals_CustomerCategoryID)
	WITH STAT_HEADER;
GO

UPDATE STATISTICS Sales.SpecialDeals
WITH FULLSCAN;
GO

/*Example 2  */
-->>>>Creating a Maintenance Plan
--to update statistics----------
/*
Enable SQL Server Agent  right click and select START
Expand Management node
Right click on Maintenance Plans folder
Select New Maintenance Plan 
       or Maintenance Plan Wizard
Select Update Statistics Task from Toolbox or Task list
*/

--Create a Maintenance Plan to Update Statistics
--on Sales.SpecialDeals table

DBCC SHOW_STATISTICS ('Sales.SpecialDeals', 
	FK_Sales_SpecialDeals_CustomerCategoryID)
	--WITH STAT_HEADER;
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>