/*70-762 Lesson 1.13 Lab 5 Using DDM Functions */


USE WideWorldImporters
GO


-- To drop the schema it must be empty-----
--DROP SCHEMA IF EXISTS Examples;
--GO

--CREATE SCHEMA Examples;
--GO

DROP TABLE IF EXISTS Examples.MaskedEmployees;
GO

CREATE TABLE [Examples].[MaskedEmployees](
	[empid] [int] IDENTITY(1,1) NOT NULL,
	[name] [nvarchar](20) NOT NULL,
	[title] [nvarchar](30) MASKED WITH (FUNCTION = 'default()')  NOT NULL,
	[emailaddress] [nvarchar](100) NULL,
	[hiredate] [date] NOT NULL,
	[mgrid] [int] NULL,
 CONSTRAINT [PK_MaskedEmployees] PRIMARY KEY CLUSTERED 
(
	[empid] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

USE WideWorldImporters
GO

INSERT INTO Examples.MaskedEmployees (name,title,emailaddress,hiredate,mgrid)
     VALUES
           (N'Mickey', N'CEO','mick@toon.plc','1928-11-18',NULL),
		   (N'Minnie', N'VP Animation','minn@toon.plc', '1928-11-18',1),
		   (N'Donald', N'Story Manager','don@toon.plc','1934-06-09',2),
		   (N'Daisy', N'Story Writer','daisy@toon.plc','1940-06-07',3),
		   (N'Grumpy', N'Story Research','grumpy@toon.plc','1938-02-04',2),
		   (N'Happy', N'Story Development','happy@toon.plc','1938-02-04',5),
		   (N'Dopey', N'Story Development','dopey@toon.plc','1938-02-04',5);

GO

SELECT * 
FROM Examples.MaskedEmployees;
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--Create a new user MaskedUser, and grant SELECT permission on table to user---
--MaskedUser will view data as masked when querying MaskedEmployees table -----
DROP USER IF EXISTS MaskedUser;
GO

CREATE USER MaskedUser WITHOUT LOGIN;
GRANT SELECT ON Examples.MaskedEmployees TO MaskedUser;
GO

--Note that maskeduser is not able to see that job titles of the employees
EXECUTE AS USER = 'MaskedUser';
SELECT * FROM Examples.MaskedEmployees;
REVERT;

--However, maskeduser is still able to see the managerial structure----------
--Use a random masking function on the mgrid column--------------------------
ALTER TABLE Examples.MaskedEmployees
ALTER COLUMN mgrid ADD MASKED WITH (FUNCTION = 'random(3,10)');

SELECT * FROM Examples.MaskedEmployees;
GO 

EXECUTE AS USER = 'MaskedUser';
SELECT * FROM Examples.MaskedEmployees;
REVERT;

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--ALTER TABLE to mask the hiredate column using the default masking function--
ALTER TABLE Examples.MaskedEmployees
ALTER COLUMN hiredate ADD MASKED WITH (FUNCTION = 'default()');

SELECT * FROM Examples.MaskedEmployees;
GO 

EXECUTE AS USER = 'MaskedUser';
SELECT * FROM Examples.MaskedEmployees;
REVERT;

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--ALTER TABLE to mask the emailaddress column using the email masking function--
ALTER TABLE Examples.MaskedEmployees
ALTER COLUMN emailaddress ADD MASKED WITH (FUNCTION = 'email()');

SELECT * FROM Examples.MaskedEmployees;
GO 

EXECUTE AS USER = 'MaskedUser';
SELECT * FROM Examples.MaskedEmployees;
REVERT;

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--ALTER TABLE to mask the name column using the custom string masking function--
ALTER TABLE Examples.MaskedEmployees
ALTER COLUMN name ADD MASKED WITH (FUNCTION = 'partial(1,"****",2)');

SELECT * FROM Examples.MaskedEmployees;
GO 

EXECUTE AS USER = 'MaskedUser';
SELECT * FROM Examples.MaskedEmployees;
REVERT;

--Enable MaskedUser to see all data --------------------------
GRANT UNMASK TO MaskedUser;

EXECUTE AS USER = 'MaskedUser';
SELECT * FROM Examples.MaskedEmployees;
REVERT;

--DELETE user MaskedUser-----------------------------------------
DROP USER IF EXISTS MaskedUser;
GO

