/* 70-762 Lesson 10 Lab 3 - Connection 1 - 
Using SQL Server Profiler and Extended Events Viewer to Capture Deadlock Information*/


/* Create Lesson 10 lab environment 
   Uncomment code if not created in Lab 1 */
-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-->>>>Create tables in Examples schema of WideWorldImporters database<<<<-----------------
USE WideWorldImporters;
GO

--DROP TABLE IF EXISTS Examples.LockingTable1;
--GO

--DROP TABLE IF EXISTS Examples.LockingTable2;
--GO

--CREATE TABLE Examples.LockingTable1
--	(col1 int NOT NULL
--		CONSTRAINT PK_Examples_LockingTable1 PRIMARY KEY,
--	col2 varchar(100) NOT NULL);

--INSERT INTO Examples.LockingTable1 (col1, col2)
--VALUES (1, 'Red'), (2, 'Orange'), (3, 'Yellow'), (4, 'Green');
--GO

-------------------------
--CREATE TABLE Examples.LockingTable2
--	(col1 int NOT NULL
--		CONSTRAINT PK_Examples_LockingTable2 PRIMARY KEY,
--	col2 varchar(100) NOT NULL);

--INSERT INTO Examples.LockingTable2 (col1, col2)
--VALUES (1, 'Blue'), (2, 'Indigo'), (3, 'Violet'), (4, 'Spectrum');
--GO

--Connection 1--------------------------

BEGIN TRANSACTION;
	UPDATE Examples.LockingTable1
		SET Col2 = 'Scarlet is the new Red'
		WHERE col1 = 1;
	WAITFOR DELAY '00:00:10';
	UPDATE Examples.LockingTable2
		SET Col2 = 'Row 1 updated a second time'
		WHERE col1 = 1;

--Connection 1 is deadlock victim and 
--updates rolled back----------------

SELECT *
FROM Examples.LockingTable1;

SELECT *
FROM Examples.LockingTable2

--COMMIT TRANSACTION must be executed in connection 2;

/***************************************************/
-------Example 2------------------------------------
/*--Run SQL Server Profiler-----------------------*/
--Set up example again and execute with profiler running

--Using SQL Server Profiler
--In SSMS Tools menu, click SQL Server Profiler
--Connect to instance of SQL Server and start new trace
--Click Events tab and select Show all events checkbox
--Expand Locks and select:
--Deadlock Graph
--Lock:Deadlock
--Lock:Deadlock Chain
--On Events Extraction Settings tab select to Save Deadlock XML events separately


----Connection 1-----------------------------------
BEGIN TRANSACTION;
	UPDATE Examples.LockingTable1
		SET Col2 = 'Scarlet is the new Red'
		WHERE col1 = 1;
	WAITFOR DELAY '00:00:10';
	UPDATE Examples.LockingTable2
		SET Col2 = 'Row 1 updated a second time'
		WHERE col1 = 1;

SELECT *
FROM Examples.LockingTable1;

SELECT *
FROM Examples.LockingTable2

COMMIT TRANSACTION

/***************************************************/
/***************************************************/
-------Example 3------------------------------------
/*--Using Extended Events Viewer-------------------*/
--to capture deadlock information------------------

-- First query extended events dynamic management views
-- to identify if SYSTEM_HEALTH trace is on server
-- and xml_deadlock_report included in trace
SELECT s.name, se.event_name 

FROM sys.dm_xe_sessions s

INNER JOIN sys.dm_xe_session_events se ON (s.address = se.event_session_address) and (event_name = 'xml_deadlock_report')

WHERE name = 'system_health'

----------------------------------------------------------------------
--Query the system_health*.xel file
-- for the xml_deadlock_report-------

SELECT CONVERT(xml, event_data).query('/event/data/value/child::*'), 

CONVERT(xml, event_data).value('(event[@name="xml_deadlock_report"]/@timestamp)[1]','datetime') as Execution_Time

FROM sys.fn_xe_file_target_read_file('C:\Program Files\Microsoft SQL Server\MSSQL13.MSSQLSERVER01\MSSQL\Log\system_health*.xel', null, null, null)

WHERE object_name like 'xml_deadlock_report'

/*********************************************************************/
/*********************************************************************/
