/*70-762 Lesson 3.2 Lab 1 - Implementing a View Structure */

Use WideWorldImporters;
GO

/**Using a view to Hide or Limit Data-----------------**/
--Wide World Importers wants to provide a tool for sales staff
--which displays customer names, contact person, phone number, standard discount percentage

/** Creating SELECT statement for reference to data requirements---*/
--SELECT c.CustomerID,c.CustomerName, p.FullName AS ContactPersonName, c.PhoneNumber, c.StandardDiscountPercentage
--FROM Sales.Customers AS c
--JOIN
--Application.People AS p
--ON  c.PrimaryContactPersonID = p.PersonID
--ORDER BY c.CustomerName;
--GO

DROP VIEW IF EXISTS Sales.vCustomerContactInfo;
GO


CREATE VIEW Sales.vCustomerContactInfo
AS
SELECT c.CustomerName AS Customer, p.FullName AS 'Contact Person', c.PhoneNumber, c.StandardDiscountPercentage
FROM Sales.Customers AS c
JOIN
Application.People AS p
ON  c.PrimaryContactPersonID = p.PersonID;
GO

SELECT *
FROM Sales.vCustomerContactInfo
ORDER BY Customer;
GO 

DROP VIEW IF EXISTS Sales.vCustomerContactInfo;
GO

/**Using a view to Reformat Output Data-----------------**/
--Wide World Importer's Human Resources department has asked
--for an easyway to differentiate their regular employees,
--sales employees, and non-employees-----------------------
USE WideWorldImporters;
GO

SELECT PersonID, FullName, IsEmployee, IsSalesPerson
FROM Application.People;
GO

DROP VIEW IF EXISTS Application.vEmploymentPosition;
GO

CREATE VIEW Application.vEmploymentPosition
AS
SELECT PersonID, FullName, IsEmployee, IsSalesPerson,
	CASE WHEN IsEmployee = 1 AND IsSalesperson = 1
			  THEN 'Sales Person'
		 WHEN IsEmployee = 1
			  THEN 'Employee'
		 ELSE 'Not Employee'
	END AS 'Employment Position'
FROM Application.People;
GO

SELECT PersonID, FullName, [Employment Position]
FROM Application.vEmploymentPosition
WHERE [Employment Position] IN ('Employee', 'Sales Person')
ORDER BY FullName;
GO

SELECT PersonID, FullName, [Employment Position]
FROM Application.vEmploymentPosition
ORDER BY FullName;
GO

DROP VIEW IF EXISTS Application.vEmploymentPosition;
GO

/**Using a View as a Reporting Interface-------*/
--Wide World Importers Sales department has hired a new manager 
--for the Southwest division of the company. 
--They want to provide a report to the new manager
--displaying cities and states currently being served.

USE WideWorldImporters;
GO

DROP VIEW IF EXISTS Application.vSouthwestSalesTerritory;
GO

CREATE OR ALTER VIEW Application.vSouthwestSalesTerritory
	WITH SCHEMABINDING
AS
SELECT  C.CityName, P.StateProvinceName
FROM Application.StateProvinces AS P
JOIN Application.Cities AS C
  ON P.StateProvinceID = C.StateProvinceID
  WHERE p.SalesTerritory = 'Southwest'; 
GO


SELECT *
FROM Application.vSouthwestSalesTerritory
ORDER BY CityName, StateProvinceName;
GO

SELECT *
FROM Application.vSouthwestSalesTerritory
ORDER BY StateProvinceName, CityName;
GO

DROP VIEW IF EXISTS Application.vSouthwestSalesTerritory;
GO

