/*70-762 Lesson 4.2 Lab 1 - Understanding the Conceptual Format of Columnstore Indexes */

/**Using a clustered columnstore index in large data warehouse table**/
--WideWorldImportersDW.Fact.Order table includes a clustered
--columnstore index 
--Use Ctrl-M to Include Actual Execution Plan-----------------------
Use WideWorldImportersDW;
GO

SELECT [Order Key]
	  ,[Customer Key]
      ,[Stock Item Key]
      ,[Order Date Key]
      ,[WWI Order ID]
      ,[Description]
	  ,[Total Excluding Tax]
  FROM [WideWorldImportersDW].[Fact].[Order];
GO


/**Real-time analytics uses an updateable columnstore index on rowstore table 
Columnstore index maintains copy of data 
OLTP and analytics workloads run against separate data copies **/
--WideWorldImporters.Sales.InvoiceLines table includes a nonclustered
--columnstore index 
--Use Ctrl-M to Include Actual Execution Plan-----------------------


Use WideWorldImporters;
GO

--Query uses Nonclustered Columnstore Index---
SELECT top 10 InvoiceID, sum (UnitPrice)  
FROM Sales.InvoiceLines 
WHERE UnitPrice > 100.0   
Group By InvoiceID;
GO

--Query uses Clustered B-tree Index--------
SELECT InvoiceID, InvoiceLineID, StockItemID
FROM Sales.InvoiceLines
Where InvoiceLineID = 200
ORDER BY StockItemID;
GO  

