/* 70-762 Lesson 7 Lab 2 - Implementing DML Triggers */

/*  -- Understand Inserted and Deleted Tables When Using an AFTER Trigger */

USE CertLiveDB
GO

--Create Production.Categories table --
DROP TABLE IF EXISTS Production.Categories;
GO

CREATE TABLE Production.Categories(
	CategoryID INT IDENTITY(1,1) NOT NULL,
	CategoryName NVARCHAR (100),
	Description NVARCHAR(max)
	CONSTRAINT PK_Categories_CategoryID PRIMARY KEY(CategoryID),
);
GO

--INSERT VALUES INTO CATEGORIES TABLE --
INSERT INTO Production.Categories (categoryname ,description)
	VALUES(N'SQL 2016 Database Administration', N'Microsoft Solutions Associate'),
	(N'SQL 2016 Database Development', N'Microsoft Certified Solutions Expert'),
	(N'Mobility', N'Microsoft Certified Solutions Expert');
GO

SELECT *
FROM Production.Categories;
GO

/* Delete Trigger if already created in table */
DROP TRIGGER IF Exists Production.trCategories_Test;
GO

/* CREATE the AFTER Trigger to display the inserted and deleted tables
   created by the trigger
 */
CREATE TRIGGER Production.trCategories_Test
ON Production.Categories
AFTER INSERT, UPDATE, DELETE
AS
BEGIN
  SELECT * FROM inserted
  SELECT * FROM deleted
END;
GO

/* INSERT a new row INTO the Categories table.
   The inserted and deleted tables from the trigger are displayed
*/
INSERT INTO Production.Categories (CategoryName ,description)
	VALUES(N'MCSA Windows Server 2016', N'Microsoft Solutions Associate');
GO

/* DELETE a row FROM the Categories table.
   The inserted and deleted tables from the trigger are displayed
*/
DELETE FROM Production.Categories
	WHERE CategoryName = 'MCSA Windows Server 2016';
GO 

/* INSERT a new row INTO the Categories table.
   The inserted and deleted tables from the trigger are displayed
*/
INSERT INTO Production.Categories (categoryname ,description)
	VALUES(N'MCSA Windows Server 2016', N'Microsoft Solutions Associate');
GO

/* Display the data in the Categories table */
SELECT CategoryID
FROM Production.Categories
WHERE CategoryName = 'MCSA Windows Server 2016';
GO

/* UPDATE a row in the Categories table.
   The inserted and deleted tables from the trigger are displayed
*/
UPDATE Production.Categories
SET CategoryName = 'MCSA Web Applications'
WHERE CategoryID = 5

/* Display the data in the Categories table */
SELECT *
FROM Production.Categories;
GO

/* Delete the MCSA Windows Server 2012 row */
DELETE FROM Production.Categories
	WHERE CategoryName = 'MCSA Web Applications';
GO 

/* Delete the trigger */
DROP TRIGGER IF EXISTS Production.trCategories_Test;
GO

/* Display the data in the Categories table */
SELECT *
FROM Production.Categories;
GO