/* 70-762 Lesson 8 Lab 1 - Implementing and Exploring Transaction Behavior */

/* EXAMPLE 1 */
-->>>>>>>>>>Using a Named Transaction with ROLLBACK
-->>>>Create a table<<<<-----------------
USE WideWorldImporters;
GO

DROP TABLE IF EXISTS Examples.TranTable;
GO

CREATE TABLE Examples.TranTable (col1 int);
GO

DECLARE @TranName varchar(20) = 'TranTest';
SELECT @@TRANCOUNT AS 'TRANCOUNT';
-->>Start a named transaction,
-->>insert two rows
-->>then roll back the transaction
BEGIN TRAN @TranName
       INSERT INTO Examples.TranTable VALUES(10), (20);
	   SELECT @@TRANCOUNT AS 'TRANCOUNT';
ROLLBACK TRAN @TranName;
SELECT @@TRANCOUNT AS 'TRANCOUNT';
SELECT col1 FROM Examples.TranTable;
-----------------------------------------------------------
-->>>>Insert two rows outside the transaction<<<<----------
INSERT INTO Examples.TranTable VALUES(30),(40);
SELECT @@TRANCOUNT AS 'TRANCOUNT';
-->>>>Result set only contains the last two rows entered outside the transaction<<<<--
SELECT col1 FROM Examples.TranTable;

----------------------------------------------------------------
----------------------------------------------------------------

/* EXAMPLE 2 */
-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-->>>>Using NESTED TRANSACTIONS with ROLLBACK and @@TRANCOUNT--
-->>>>>>NOTE: Only one ROLLBACK Needed<<<<<<-------------------
USE WideWorldImporters;
GO

-->>>>Delete table<<<<--
DROP TABLE IF EXISTS Examples.TranTable;
GO

CREATE TABLE Examples.TranTable (col1 int);
GO

DECLARE @TranName varchar(20) = 'TranTest';
SELECT @@TRANCOUNT AS 'TRANCOUNT';
-->>Start a named transaction,
-->>insert two rows
-->>then roll back the transaction
BEGIN TRAN @TranName
	SELECT @@TRANCOUNT AS 'TRANCOUNT';
	BEGIN TRAN;
       INSERT INTO Examples.TranTable VALUES(10), (20);
	   SELECT @@TRANCOUNT AS 'TRANCOUNT';
ROLLBACK TRAN @TranName;
SELECT @@TRANCOUNT AS 'TRANCOUNT';
-->>>>Insert two rows outside the transaction<<<<-------
INSERT INTO Examples.TranTable VALUES(30),(40);
SELECT @@TRANCOUNT AS 'TRANCOUNT';
-->>>>Result set only contains the last two rows entered outside the transaction<<<<--
SELECT col1 FROM Examples.TranTable;

/* EXAMPLE 3 */
------------------------------------------------------
------------------------------------------------------
-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-->>>>Using NESTED TRANSACTIONS and @@TRANCOUNT----------------
-->>>>>>NOTE: Two COMMIT TRAN statements Needed<<<<<<----------
-->>>>>>Otherwise transaction is still open with @@TRANCOUNT of 1--
USE WideWorldImporters;
GO

-->>>>Delete table<<<<--
DROP TABLE IF EXISTS Examples.TranTable;
GO

CREATE TABLE Examples.TranTable (col1 int);
GO

DECLARE @TranName varchar(20) = 'TranTest';
SELECT @@TRANCOUNT AS 'TRANCOUNT';
-->>Start a named transaction,
-->>insert two rows
-->>then commit the nested transaction
BEGIN TRAN @TranName
	SELECT @@TRANCOUNT AS 'TRANCOUNT';
	BEGIN TRAN;
       INSERT INTO Examples.TranTable VALUES(10), (20);
	   SELECT @@TRANCOUNT AS 'TRANCOUNT';
	COMMIT TRAN @TranName;
SELECT @@TRANCOUNT AS 'TRANCOUNT';
-->>>>Insert two rows outside the transaction<<<<-------
INSERT INTO Examples.TranTable VALUES(30),(40);
SELECT @@TRANCOUNT AS 'TRANCOUNT';
IF @@TRANCOUNT > 0  COMMIT TRAN --Transaction committed if trancount > 0
-->>>>Result set<<<<--
SELECT col1 FROM Examples.TranTable;
SELECT @@TRANCOUNT AS 'TRANCOUNT';

-->>>>Delete table<<<<--
DROP TABLE IF EXISTS Examples.TranTable;
GO